#include <boost/graph/adjacency_list.hpp>
#include <boost/graph/breadth_first_search.hpp>
#include <boost/pending/indirect_cmp.hpp>
#include <boost/pending/integer_range.hpp>

#include <iostream>

using namespace boost;

int main()
{
  typedef adjacency_list <vecS, vecS, undirectedS> graph_t;
  enum { r, s, t, u, v, w, x, y, N };
  typedef std::pair <int, int> Edge;
  Edge edge_array[] = { Edge(r, s), Edge(r, v), Edge(s, w), Edge(w, r), 
                        Edge(w, t), Edge(w, x), Edge(x, t), Edge(t, u), 
                        Edge(x, y), Edge(u, y)
  };

  const int n_edges = sizeof(edge_array) / sizeof(Edge);
  typedef graph_traits<graph_t>::vertices_size_type v_size_t;
  graph_t g(edge_array, edge_array + n_edges, v_size_t(N));

  std::vector<int> p(boost::num_vertices(g));
  boost::graph_traits<graph_t>::vertices_size_type d[N];
  std::fill_n(d, size_t(N), 0);

  boost::breadth_first_search
    (g, s, 
     boost::visitor(boost::make_bfs_visitor
     (std::make_pair(boost::record_distances(d, boost::on_tree_edge()),
                     boost::record_predecessors(&p[0], 
                                                boost::on_tree_edge())
       ))));



  return EXIT_SUCCESS;
}
